/*========================================================================
	PCD.c
			Written by Igarashi
========================================================================*/
/*========================================================================
@{t@C̒쌠͍ҁi炵jɑ܂Ap҂̏펯ƐӔC
͈͂ɂāARɎgp /  / zt / 邱Ƃł܂B̍ہA
߂KvȂ΁ACeB̗ނؕKv܂B

@{t@C͖ۏ؂łB{t@CgpʂɂāA҂͈؂
ӔC𕉂Ȃ̂Ƃ܂B
========================================================================*/

/*	modified for hybrid coerce 1999/4/25 by Rick	*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	"libpcd.h"
#include	"defs.h"
#include	"PCD.h"

extern void pcd_maketable( void );

extern int	pcd_errno;
extern char	*pcd_errorarg;

static int	initflag = FALSE;

/*------------------------------------------------------------------------

------------------------------------------------------------------------*/
static void pcd_init( void )
{
	pcd_maketable();
}

/*------------------------------------------------------------------------
	PhotoCD t@C̔
		errno ݒ:	yes
------------------------------------------------------------------------*/
static int pcd_ispcdfile( PCDINFO *p )
{
	int	ret = FALSE;
	if ( fseek( p->fp, 0x800, SEEK_SET )) {
		pcd_errno = PCD_CANTREAD;		/* V[NG[ */
	} else {
		char	buf[8];
		if ( fread( buf, 8, 1, p->fp ) != 1 ) {
			pcd_errno = PCD_CANTREAD;		/* [hG[G[ */
		} else {
			if ( strcmp( buf, "PCD_IPI" )) {
				pcd_errno = PCD_UNKNOWNFORMAT;	/* T|[gȂ */
			} else {
				ret = TRUE;
			}
		}
	}
	return ret;
}

/*------------------------------------------------------------------------
	𑜓xʃwb_iHjǂ
		errno ݒ:	yes
------------------------------------------------------------------------*/
static unsigned char *pcd_read_header( PCDINFO *p, short reso )
{
#define	PCD_HEADSIZE	0x200	/* wb_TCY */

	size_t	headpos;
	unsigned char	*buf;

	switch ( reso ) {
		case PCD_OVERVIEW16:
			headpos = 0x0e00;
			break;
		case PCD_OVERVIEW4:
			headpos = 0x1000;
			break;
		case PCD_BASE:
			headpos = 0x1200;
			break;
		case PCD_4BASE:
			headpos = 0x1400;
			break;
		case PCD_16BASE:
			headpos = 0x1600;
			break;
		default:
			pcd_errno = PCD_ILLEGALRESOLUTION;
			return NULL;
			break;
	}
	if (( buf = malloc( PCD_HEADSIZE )) == NULL ) {
		pcd_errno = PCD_NOMEMORY;		/* malloc G[ */
		return NULL;
	}
	if ( fseek( p->fp, headpos, SEEK_SET )) {
		pcd_errno = PCD_CANTREAD;		/* V[NG[ */
		return NULL;
	}
	if ( fread( buf, PCD_HEADSIZE, 1, p->fp ) != 1 ) {
		pcd_errno = PCD_CANTREAD;		/* [hG[G[ */
		return NULL;
	}
	return buf;
}

/*========================================================================
	.PCD ̃I[v
	based on open.c ( libpcd v0.20 )
========================================================================*/
int pcd_open2( PCDINFO *p, short reso, char *filename )
{
	int		width, height;
	size_t	datatop;
	unsigned char	*header;

	p->fp = NULL;
	p->YCCbuf = NULL;

	switch ( reso ) {
		case PCD_OVERVIEW16:
			width = 192;
			height = 128;
			datatop = 0x2000;
			break;
		case PCD_OVERVIEW4:
			width = 384;
			height = 256;
			datatop = 0xb800;
			break;
		case PCD_BASE:
			width = 768;
			height = 512;
			datatop = 0x30000;
			break;
		case PCD_4BASE:
			width = 1536;
			height = 1024;
			datatop = 0x0;		/* s */
			break;
		case PCD_16BASE:
			width = 3072;
			height = 2048;
			datatop = 0x0;		/* s */
			break;
		default:
			pcd_errno = PCD_ILLEGALRESOLUTION;
			return FALSE;
			break;
	}
	p->reso = reso;

	/* t@CI[v */
#if 0
	if ( filename == NULL ) {		/* W */
			p->fp = stdin;
	} else {
		if (( p->fp = fopen( filename, "rb" )) == NULL ) {
			pcd_errno = PCD_FILENOTFOUND;
			pcd_errorarg = filename;
			return FALSE;
		}
	}
#else
	if ( fp == NULL ) {		/* fp: global variable */
		if (( fp = fopen( filename, "rb" )) == NULL ) {
			pcd_errno = PCD_FILENOTFOUND;
			pcd_errorarg = filename;
			return FALSE;
		}
	}
	p->fp = fp;
#endif

	if ( !initflag ) {	/* KvɉďiӖsj */
		pcd_init();
		initflag = TRUE;
	}

	if ( !pcd_ispcdfile( p )) {
		return FALSE;
	}

	/* wb_[h */
	if (( header = pcd_read_header( p, reso )) == NULL ) {
		return FALSE;
	}

	/* 摜f[^擪փV[N */
	if ( fseek( p->fp, datatop, SEEK_SET )) {
		free( header );
		pcd_errno = PCD_CANTREAD;		/* V[NG[ */
		return FALSE;
	}

	/* YCC [hpobt@m */
	if (( p->YCCbuf = malloc( width * 4 )) == NULL ) {
		free( header );
		pcd_errno = PCD_NOMEMORY;		/* malloc G[ */
		return FALSE;
	}

	p->width = width;
	p->height = height;
	p->readline = 0;
	p->rot = header[2] & 0x03;	/* ]i炵j */
	switch ( p->rot ) {
		case 0:
		case 2:
			p->xsize = p->width;
			p->ysize = p->height;
			break;
		case 1:
		case 3:
			p->xsize = p->height;
			p->ysize = p->width;
			break;
	}
	free( header );

	return TRUE;
}

extern int pcd_to0grb( PCDINFO *, unsigned short *, int );

/*========================================================================
	PCD?Load() 
========================================================================*/
static void PCDLoad( short reso )
{
	PCDINFO	pcd;

	if ( !pcd_open2( &pcd, reso, File ))	/* PCD I[v */
		error ("%s: Load error.");

	Width = pcd.xsize;		/* Width: global variable */
	Height = pcd.ysize;		/* Height: global variable */

	if( OutBpp == 2 ){
		AllocateScreen();
		if ( !pcd_to0grb( &pcd, Screen, 0 ))
			error ("%s: Load error.");
		MaxColorGuaranteed = 32768;
		InBpp= 2;
	}else {
		AllocateScreen24();
		if ( !pcd_torgb( &pcd, Screen, 0 ))
			error ("%s: Load error.");
		MaxColorGuaranteed = 16777216;
	}
	pcd_close( &pcd );
}

void PCD0Load( void )
{
	PCDLoad( 0 );
}

void PCD1Load( void )
{
	PCDLoad( 1 );
}

void PCD2Load( void )
{
	PCDLoad( 2 );
}

